'use strict';
import allHeroesJson from "../assets/all-heroes.json";
import Hero from './Hero';
import HeroAbility from './HeroAbility';


export default class HeroFactory {
  constructor() {

  }

  getHeroesSet() {
    let abilitiesMap = new Map();
    allHeroesJson.abilities.forEach(ability => {
      let abilityObj = new HeroAbility(ability.abilityName,
        ability.abilityHook,
        ability.optionnal,
        ability['abilityDesc-FR']);
      abilitiesMap.set(ability.abilityName, abilityObj);
    });

    let heroesSet = new Set();
    allHeroesJson.heroes.forEach(hero => {
      let i = 0;
      while (i < hero.nbInDeck) {
        let heroObj = new Hero(
          hero.name,
          hero.cost,
          hero.power,
          hero.faction,
          abilitiesMap.get(hero.ability),
          hero.draftMode
        );
        heroesSet.add(heroObj);
        i++;
      }
    });
    return heroesSet;
  }

}
